; ___________________________________________________
;|                                                   |
;|       FarOut Media PLayer/Recorder, v1.0.0        |
;|___________________________________________________|
;|                                                   |
;| A neat little media sound player program. It can  |
;| play these formats:  AVI,MPEG,WAV,MP3,MID,WMV, as |
;| well as others. A method of previewing your       |
;| choice is included.                               |
;|                                                   |
;| 25MAR2008  Added the ability to record and save   |
;| sound strings. Also included is the ability to    |
;| modify existing waves by recording over a portion |
;| of the content. The ability to INSERT is in       |
;| development.                                      |
;|                                         PBrennick |
;|___________________________________________________|
;|                                                   |
    .586               ; Select target CPU [Minimum] |
    .model  flat, stdcall      ; 32 bit memory model |
    option  casemap :none      ; Case Sensitive == 1 |
;|___________________________________________________|
;
;   Include Files
;   ----------------------------------------
    include \GeneSys\include\windows.inc
    include \GeneSys\include\comctl32.inc
    include \GeneSys\include\user32.inc
    include \GeneSys\include\kernel32.inc
    include \GeneSys\include\gdi32.inc
    include  \GeneSys\include\winmm.inc
    include msvfw32.inc

;   Libraries
;   ----------------------------------------
    includelib  \GeneSys\lib\comctl32.lib
    includelib  \GeneSys\lib\user32.lib
    includelib  \GeneSys\lib\kernel32.lib
    includelib  \GeneSys\lib\gdi32.lib
    includelib  \GeneSys\lib\winmm.lib
    includelib  msvfw32.lib

; Local Prototypes
;-------------------------------------------
AbtDlgProc      PROTO   :DWORD, :DWORD, :DWORD, :DWORD
Center_Window   PROTO   :DWORD
DefToolbar      PROTO
DlgProc         PROTO   :HWND,  :DWORD, :DWORD, :DWORD
dw2hex          PROTO   :DWORD, :DWORD

; Constants [Equates]
;-------------------------------------------
.const
;---------------------------------------
ID_TIMER        equ 1
IDD_ABOUT       equ 4000
IDI_ICON1       equ 500
IDM_ABOUT       equ 2001
TButtons        equ 7
IDB_BITMAP      equ 101
IDC_CLOSE       equ 200
IDB_TOOLBAR     equ 201
IDC_UNOTES      equ 202
IDC_PNOTES      equ 203
IDC_TITLE_1     equ 204
IDC_TITLE_2     equ 205
IDM_PLAY        equ 601
IDM_RECORD      equ 602
IDM_PAUSE       equ 603
IDM_STOP        equ 604
IDM_EXIT        equ 605
IDM_OPEN        equ 606
IDM_REPEAT      equ 607

; Initialized Data
;---------------------------------------
.data
AppName         db  " Media Sound Player/Recorder", 0
DlgName         db  "MyDialog", 0
OurTitle        db  "Pick a Media Sound File!", 0  ; Title for file dialog to Pick Sound
FilterString    db  "Wave Files", 0, "*.wav", 0
                db  "MPeg Files", 0, "*.mp3", 0
                db  "MIDI Files", 0, "*.mid", 0
                db  "RMI Sound Files", 0, "*.rmi", 0
                db  "MOV Sound Files", 0, "*.mov", 0
                db  "AIF Sound Files", 0, "*.aif", 0
                db  "AU Sound Files", 0, "*.au", 0
                db  "All Files", 0, "*.*", 0, 0
szFontName      db  "MS Sans Serif", 0
PlayCommand     db  "play", 0
PauseCommand    db  "pause", 0
StopCommand     db  "stop", 0
CloseCommand    db  "close", 0
szPosition      db  "status position", 0
PlayState       dd  FALSE
CommandLine     db  "waveaudio", 247 dup(0)

MyBlog      db  "Even though my disability has become problematic, I still want to be a part "
            db  "and I still want to help. This product is a work in"
            db  " progress and represents the beginnings of my return. I will be working on a "
            db  "Playlist option next (already have the queueing working). I do not know if I "
            db  "will add the slide control as I do not see much value in it. I want to add so"
            db  "me edit capabilities which will require a different type of progress indicato"
            db  "r, anyway. But I mention it here to see how others feel about it. I COULD add"
            db  " it as an option that can be turned on and off. At any rate, I WILL add a Sta"
            db  "tusBar that will display song lengths and current position values and some ot"
            db  "her things that I am dreaming about. This software will never be Screenblast "
            db  "Sound Forge or ACID which I use a lot, but it will allow me to edit content v"
            db  "ia insertion and deletion, etc.", 13, 10, 13, 10, "-- PBrennick", 0, 0
UserBlog    db  "Some Notes for the User:", 13, 10, "------------------------", 13, 10
            db  "Record Function:", 13, 10, "~~~~~~~~~~~~~~~~", 13, 10
            db  "Even though the Play Function is able to handle many formats, the Record Function will always save as Wave files.", 13, 10, 13, 10
            db  "Repeat Function:", 13, 10, "~~~~~~~~~~~~~~~~", 13, 10
            db  "If the Repeat Button or Menu selection is selected any song or sound string "
            db  "that is played will continually replay. If it is de-selected while something "
            db  "is playing, the current action will still be completed unless the Stop Butto"
            db  "n is pressed. If the Stop Button is pressed while something is playing and "
            db  "if the Repeat Function is enabled; it will be disabled.", 13, 10, 13, 10
            db  "Queuing:", 13, 10, "~~~~~~~~", 13, 10
            db  "If you open another song while a song is currently playing and if the Repeat "
            db  "Function is enabled; the new song will be queued and will be played when the "
            db  "current song finishes. If the Repeat Function is not enabled; the new song "
            db  "will be queued but will not be played until the Play Button is pressed which "
            db  "will re-enable when the current song finishes.", 13, 10, 13, 10, 0, 0

; Uninitialized Data
;-------------------------------------------
.data?
hInstance       HINSTANCE   ?
TBButtons       TBBUTTON    TButtons DUP ({})
ofn             OPENFILENAME    <>
wav_name        db  MAX_PATH dup(?)
CharBuffer      db  MAX_PATH dup(?)
hIcon           dd  ?
hFont1          dd  ?
hMCIWnd         dd  ?
hTBWnd          dd  ?
hSTBWnd         dd  ?

; Program Code Starts Here
;-------------------------------------------
.code
start:
    invoke  GetModuleHandle, NULL
    mov     hInstance, eax
    invoke  DialogBoxParam, hInstance, ADDR DlgName, NULL, addr DlgProc, NULL
    invoke  ExitProcess, eax

DlgProc proc    hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
;-------------------------------------------
    LOCAL   szReturn[1024]:BYTE
    LOCAL   sbParts[2]:DWORD
    LOCAL   Rct:RECT

    .if iMsg==WM_INITDIALOG                 ; Initialize dialog elements
      invoke  Center_Window, hWnd
      invoke  CreateFont, 24, 5, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, addr szFontName
      mov     hFont1, eax
      invoke  DefToolbar
      invoke  CreateToolbarEx, hWnd, WS_VISIBLE or WS_CHILD or WS_BORDER or \
              TBSTYLE_TOOLTIPS, IDB_TOOLBAR, TButtons, hInstance, IDB_BITMAP, \
              ADDR TBButtons, TButtons, 0, 0, 20, 20, sizeof TBBUTTON
      mov     hTBWnd, eax
;     +MCIWNDF_NOTIFYMODE should enable the notify mode but it is not working, yet
      invoke  MCIWndCreate, hWnd, hInstance, MCIWNDF_NOMENU+MCIWNDF_NOERRORDLG+MCIWNDF_SHOWALL+MCIWNDF_RECORD, addr CommandLine
      mov     hMCIWnd, eax
      invoke  CreateStatusWindow, WS_CHILD or WS_VISIBLE or \
              SBS_SIZEGRIP, NULL, hWnd, 200
      mov     hSTBWnd, eax
      invoke  GetClientRect, hSTBWnd, ADDR Rct
      mov     eax, Rct.right
      shr     eax, 2
      mov     ebx, eax                    ; 1/4, width of first part
      add     eax, ebx                    ; 1/2, width of first part
;     ------------------------------------
;     sbParts is a DWORD array of 2 members
;     ------------------------------------
      mov     [sbParts +  0],   eax       ; pixels from left
      mov     [sbParts +  4],    -1       ; last part is what is left
      invoke  SendMessage, hSTBWnd, SB_SETPARTS, 2, ADDR sbParts
      invoke  SendMessage, hMCIWnd, MCIWNDM_OPENA, 0, ADDR wav_name
      invoke  ShowWindow, hWnd, SW_HIDE
      invoke  MoveWindow, hWnd, 10, 10, 290, 140, TRUE
      invoke  MoveWindow, hMCIWnd, 4, 35, 276, 30, TRUE
      invoke  MoveWindow, hSTBWnd, 0, 85, 290, 30, TRUE
      invoke  Center_Window, hWnd
      invoke  ShowWindow, hWnd, SW_RESTORE
    .elseif iMsg==WM_CLOSE
      invoke  DeleteObject, hFont1
      invoke  EndDialog, hWnd, NULL
    .elseif iMsg==WM_COMMAND
      .if wParam == IDM_EXIT
        invoke  EndDialog, hWnd, 0
        push    1
        pop     eax
        ret
      .elseif wParam == IDM_PLAY
        .if PlayState == TRUE
          invoke  SendMessage, hMCIWnd, MCIWNDM_SENDSTRINGA, 0, ADDR PauseCommand
          mov     PlayState, FALSE
        .else
          invoke  SendMessage, hMCIWnd, MCIWNDM_SENDSTRINGA, 0, ADDR PlayCommand
          invoke  mciSendString, addr szPosition, addr szReturn, sizeof szReturn, hMCIWnd
          invoke  dw2hex, addr szReturn, addr CharBuffer
          invoke  SendMessage, hSTBWnd, SB_SETTEXT, 1, addr CharBuffer
          mov     PlayState, TRUE
        .endif
      .elseif wParam == IDM_OPEN
        mov     ofn.lStructSize, SIZEOF ofn
        push    hWnd
        pop     ofn.hWndOwner
        push    hInstance
        pop     ofn.hInstance
        mov     ofn.lpstrFilter, OFFSET FilterString
        mov     ofn.lpstrFile, OFFSET wav_name
        mov     ofn.nMaxFile, MAX_PATH
        mov     ofn.lpstrTitle, OFFSET OurTitle
        invoke  GetOpenFileNamePreviewA, ADDR ofn
        .if eax==TRUE                     ; Valid name retrieved
          invoke  SendMessage, hMCIWnd, MCIWNDM_OPENA, 0, ADDR wav_name
          invoke  SendMessage, hMCIWnd, MCIWNDM_SENDSTRINGA, 0, ADDR PlayCommand
        .endif
      .elseif wParam == IDM_STOP
        invoke  SendMessage, hMCIWnd, MCIWNDM_SENDSTRINGA, 0, ADDR StopCommand;;      invoke  SendMessage, hMCIWnd, MCIWNDM_SENDSTRINGA, 0, ADDR CloseCommand
        mov     PlayState, FALSE
      .elseif wParam == IDM_ABOUT
        invoke  DialogBoxParam, hInstance, IDD_ABOUT, hWnd, OFFSET AbtDlgProc, NULL
      .endif
    .elseif iMsg==WM_TIMER

      invoke  KillTimer, hWnd, ID_TIMER ; Finished with timer
      invoke mciSendString, ADDR szPosition, ADDR szReturn, sizeof szReturn, hMCIWnd
      invoke  dw2hex, addr szReturn, addr CharBuffer
      invoke  SendMessage, hSTBWnd, SB_SETTEXT, 1, addr CharBuffer
      invoke SetTimer, hWnd, ID_TIMER, 1000, 0  ; 1 second delay
    .else
      mov     eax, FALSE
      ret
    .endif
    mov      eax, TRUE
    ret
;-------------------------------------------
DlgProc endp

AbtDlgProc PROC hWnd:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    .if uMsg == WM_INITDIALOG
      Invoke  LoadIcon, hInstance, IDI_ICON1
      mov     hIcon, eax
      Invoke  SendMessage, hWnd, WM_SETICON, 1, eax
      invoke  DestroyIcon, hIcon
      invoke  SendDlgItemMessage, hWnd, IDC_TITLE_1, WM_SETFONT, hFont1, 0
      invoke  SetDlgItemText, hWnd, 300, addr MyBlog
    .elseif uMsg == WM_CLOSE
      invoke  EndDialog, hWnd, NULL
    .elseif uMsg == WM_COMMAND
      mov     eax, wParam
      .if ax == IDC_CLOSE
        invoke  SendMessage, hWnd, WM_CLOSE, NULL, NULL
      .elseif ax == IDC_UNOTES
        invoke  SetDlgItemText, hWnd, 300, addr UserBlog
        invoke  GetDlgItem, hWnd, IDC_UNOTES
        invoke  EnableWindow, eax, FALSE
        invoke  GetDlgItem, hWnd, IDC_PNOTES
        invoke  EnableWindow, eax, TRUE
      .elseif ax == IDC_PNOTES
        invoke  SetDlgItemText, hWnd, 300, addr MyBlog
        invoke  GetDlgItem, hWnd, IDC_PNOTES
        invoke  EnableWindow, eax, FALSE
        invoke  GetDlgItem, hWnd, IDC_UNOTES
        invoke  EnableWindow, eax, TRUE
      .endif
    .else
      mov     eax, FALSE
      ret
    .endif
    mov     eax, TRUE
    ret
;---------------------------------------
AbtDlgProc EndP

dw2hex proc source:DWORD, lpBuffer:DWORD
;---------------------------------------
    push    eax
    push    esi
    mov     edx, lpBuffer
    mov     esi, source
    xor     eax, eax
    xor     ecx, ecx
    mov     [edx+8], al                 ; put terminator at correct length
    mov     cl, 7                       ; length of hexstring - 1
@@:
    mov     eax, esi                    ; we're going to work on AL
    and     al, 00001111b               ; mask out high nibble
    cmp     al,10
    sbb     al,69h
    das
    mov     [edx + ecx], al             ; store the asciihex(AL) in the string
    shr     esi, 4                      ; next nibble
    dec     ecx                         ; decrease counter (one byte less than dec cl :-)
    jns     @B                          ; eat them if there's any more
    pop     esi
    pop     eax
    ret
;---------------------------------------
dw2hex endp

Center_Window proc hWin:DWORD
;-------------------------------------------
    LOCAL Wtx :DWORD
    LOCAL Wty :DWORD
    LOCAL Wwd :DWORD
    LOCAL Wht :DWORD
    LOCAL rect:RECT

    invoke  GetWindowRect, hWin, addr rect
    mov     eax, rect.right
    sub     eax, rect.left
    mov     Wwd, eax
    mov     eax, rect.bottom
    sub     eax, rect.top
    mov     Wht, eax
    invoke  GetSystemMetrics, SM_CXSCREEN
    shr     eax, 1                          ; Divide screen X by 2
    mov     ebx, Wwd                        ; Get window X value
    shr     ebx, 1                          ; Divide window X by 2
    sub     eax, ebx                        ; Subtract half win X from half screen X
    mov     Wtx, eax
    invoke  GetSystemMetrics, SM_CYSCREEN
    shr     eax, 1                          ; Divide screen Y by 2
    mov     ebx, Wht                        ; Get window Y value
    shr     ebx, 1                          ; Divide window Y by 2
    sub     eax, ebx                        ; Subtract half win Y from half screen Y
    mov     Wty, eax
    invoke  SetWindowPos, hWin, 0, Wtx, Wty, 0, 0, SWP_NOZORDER or SWP_NOSIZE
    ret
;-------------------------------------------
Center_Window endp

DefToolbar  proc uses ebx
;---------------------------------------
    mov TBButtons.iBitmap,          0
    mov TBButtons.idCommand,        IDM_OPEN
    mov TBButtons.fsState,          TBSTATE_ENABLED
    mov TBButtons.fsStyle,          TBSTYLE_BUTTON
    mov TBButtons.dwData,           0
    mov TBButtons.iString,          0
    mov ebx, sizeof TBBUTTON
    mov TBButtons[ebx].iBitmap,     1
    mov TBButtons[ebx].idCommand,   IDM_PLAY
    mov TBButtons[ebx].fsState,     TBSTATE_ENABLED
    mov TBButtons[ebx].fsStyle,     TBSTYLE_BUTTON
    mov TBButtons[ebx].dwData,      0
    mov TBButtons[ebx].iString,     0
    add ebx, sizeof TBBUTTON
    mov TBButtons[ebx].iBitmap,     2
    mov TBButtons[ebx].idCommand,   IDM_RECORD
    mov TBButtons[ebx].fsState,     TBSTATE_ENABLED
    mov TBButtons[ebx].fsStyle,     TBSTYLE_BUTTON
    mov TBButtons[ebx].dwData,      0
    mov TBButtons[ebx].iString,     0
    add ebx, sizeof TBBUTTON
    mov TBButtons[ebx].iBitmap,     3
    mov TBButtons[ebx].idCommand,   IDM_PAUSE
    mov TBButtons[ebx].fsState,     TBSTATE_ENABLED
    mov TBButtons[ebx].fsStyle,     TBSTYLE_BUTTON
    mov TBButtons[ebx].dwData,      0
    mov TBButtons[ebx].iString,     0
    add ebx, sizeof TBBUTTON
    mov TBButtons[ebx].iBitmap,     4
    mov TBButtons[ebx].idCommand,   IDM_STOP
    mov TBButtons[ebx].fsState,     TBSTATE_ENABLED
    mov TBButtons[ebx].fsStyle,     TBSTYLE_BUTTON
    mov TBButtons[ebx].dwData,      0
    mov TBButtons[ebx].iString,     0
    add ebx, sizeof TBBUTTON
    mov TBButtons[ebx].iBitmap,     5
    mov TBButtons[ebx].idCommand,   IDM_REPEAT
    mov TBButtons[ebx].fsState,     TBSTATE_ENABLED
    mov TBButtons[ebx].fsStyle,     TBSTYLE_BUTTON
    mov TBButtons[ebx].dwData,      0
    mov TBButtons[ebx].iString,     0
    add ebx, sizeof TBBUTTON
    mov TBButtons[ebx].iBitmap,     6
    mov TBButtons[ebx].idCommand,   IDM_EXIT
    mov TBButtons[ebx].fsState,     TBSTATE_ENABLED
    mov TBButtons[ebx].fsStyle,     TBSTYLE_BUTTON
    mov TBButtons[ebx].dwData,      0
    mov TBButtons[ebx].iString,     0
    ret
;---------------------------------------
DefToolbar  endp

    end     start

;;;; invoke  MessageBox, hWnd, ADDR PlayCommand, ADDR PauseCommand, MB_OK

